// promise example
#include <iostream>       // std::cout
#include <functional>     // std::ref
#include <thread>         // std::thread
#include <future>         // std::promise, std::future
#include <unistd.h>

void print_int (std::future<int>& fut) {
  int x = fut.get();
  std::cout << "   after get: " << fut.valid() << '\n';
}

int main ()
{
  std::promise<int> prom;
  std::future<int> fut = prom.get_future();

  std::thread th1 (print_int, std::ref(fut));

  std::cout << "before promise set: " << fut.valid() << std::endl;
  sleep(2);
  prom.set_value (10);

  std::cout << "after promise set: " << fut.valid() << std::endl;

  th1.join();

  sleep(2);
  fut.get();
  
  std::cout << "after join: " << fut.valid() << std::endl;
 
  return 0;
}

