// promise example
#include <iostream>       // std::cout
#include <functional>     // std::ref
#include <thread>         // std::thread
#include <future>         // std::promise, std::future
#include <unistd.h>

void thread1 (std::future<int>& fut, int id) {
  std::cout << "T" << id << " valid: " << fut.valid() << "\n";
  int x = fut.get();
  std::cout << "T" << id << " valid: " << fut.valid() << "\n";
  std::cout << "T" << id << " " << x << '\n';

  //fut.wait();
}

void thread2 (std::future<int>& fut, int id) {
  std::cout << "T" << id << " valid: " << fut.valid() << "\n";
  fut.wait();
  int x = fut.get();
  x = fut.get();
  std::cout << "T" << id << " valid: " << fut.valid() << "" << x << "\n";

  //fut.wait();
  std::cout << "T" << id << " valid: " << fut.valid() << "\n";
}


int main ()
{
  std::promise<int> prom;
  std::future<int> fut = prom.get_future();

  std::thread th1 (thread1, std::ref(fut), 1);
  std::thread th2 (thread2, std::ref(fut), 2);

  char c = getchar();

  sleep(2);
  prom.set_value(10);

  th1.join();
  th2.join();

  return 0;
}
