#include <iostream>       // std::cout
#include <atomic>         // std::atomic
#include <thread>         // std::thread
#include <vector>         // std::vector

std::atomic<bool> ready (false);

void thread_func(int id) {
  while (!ready) {}                  // wait for the ready signal
};

int main ()
{
  std::thread t(thread_func,1);
  ready = true;
  t.join();

  return 0;
}

/**
main:
-> _ZNSt11atomic_boolaSEb
-> _ZNSt13__atomic_baseIbEaSEb
-> _ZNSt13__atomic_baseIbE5storeEbSt12memory_order
-> xchgb
 
The exchange operation (
xchg
) on the x86
swaps the value in a register with the value
stored in a memory location.
This is an
atomic
instruction and so can be used
to safely get a value and set the value at the
same time without interference from any
other thread or process.
xchg memoryLocation, %eax
If register
%eax
had the value 1 and
memoryLocation
had the value 0, after
this instruction the values would be 0 and 1
respectively.
 
(http://www.cs.auckland.ac.nz/compsci215s2c/lectures/robert/lecture33.pdf)

*/
