#include <iostream>       // std::cout
#include <atomic>         // std::atomic
#include <thread>         // std::thread
#include <vector>         // std::vector

std::atomic<bool> ready (false);

int a,b,c;


void thread_func(int id) {
  while (!ready) {}                  // wait for the ready signal
  
  __transaction_atomic { c = a - b; }

};

int main ()
{
  a = b = 5;
  c = 0;
  std::thread t(thread_func,1);
  ready = true;
  
  __transaction_atomic { if (a > b) b++; }
  
  t.join();

  return 0;
}
/**
http://gcc.gnu.org/wiki/TransactionalMemory
http://lwn.net/Articles/466513/
*/
